commit 123b4f5598c5dfabf3038154170f6b9012b1e1d1
Author: freddy77 <freddy77>
Date:   Wed Nov 5 14:27:49 2008 +0000

    fix problem for too dynamics reported

diff --git a/ChangeLog b/ChangeLog
index bda5fab..317bb9f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Nov 05 15:26:17 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/unittests/toodynamic.c(added) include/tds.h:
+	* src/tds/mem.c src/tds/query.c src/tds/unittests/Makefile.am:
+	- fix problem for too dynamics reported by Man Min Yan
+
 Tue Nov 04 16:24:24 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c src/odbc/unittests/cursor3.c:
 	- fix SQLGetData with cursors
@@ -884,4 +889,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2649 2008/11/04 15:24:49 freddy77 Exp $
+$Id: ChangeLog,v 1.2650 2008/11/05 14:27:49 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 8e3b812..9f33cb4 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.296 2008/10/17 09:38:10 freddy77 Exp $ */
+/* $Id: tds.h,v 1.297 2008/11/05 14:27:49 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1463,7 +1463,6 @@ int tds_submit_execute(TDSSOCKET * tds, TDSDYNAMIC * dyn);
 int tds_send_cancel(TDSSOCKET * tds);
 const char *tds_next_placeholder(const char *start);
 int tds_count_placeholders(const char *query);
-int tds_get_dynid(TDSSOCKET * tds, char **id);
 int tds_submit_unprepare(TDSSOCKET * tds, TDSDYNAMIC * dyn);
 int tds_submit_rpc(TDSSOCKET * tds, const char *rpc_name, TDSPARAMINFO * params);
 int tds_submit_optioncmd(TDSSOCKET * tds, TDS_OPTION_CMD command, TDS_OPTION option, TDS_OPTION_ARG *param, TDS_INT param_size);
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 2059a66..6680130 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -47,7 +47,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.180 2008/10/17 09:38:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.181 2008/11/05 14:27:49 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -81,6 +81,42 @@ static void tds_free_compute_result(TDSCOMPUTEINFO * comp_info);
  * @{
  */
 
+static volatile int inc_num = 1;
+
+/**
+ * Get an id for dynamic query based on TDS information
+ * \param tds state information for the socket and the TDS protocol
+ * \return TDS_FAIL or TDS_SUCCEED
+ */
+static char *
+tds_get_dynid(TDSSOCKET * tds, char *id)
+{
+	unsigned long n;
+	int i;
+	char *p;
+	char c;
+
+	CHECK_TDS_EXTRA(tds);
+
+	inc_num = (inc_num + 1) & 0xffff;
+	/* some version of Sybase require length <= 10, so we code id */
+	n = (unsigned long) (TDS_INTPTR) tds;
+	p = id;
+	*p++ = (char) ('a' + (n % 26u));
+	n /= 26u;
+	for (i = 0; i < 9; ++i) {
+		c = (char) ('0' + (n % 36u));
+		*p++ = (c < ('0' + 10)) ? c : c + ('a' - '0' - 10);
+		/* printf("%d -> %d(%c)\n",n%36u,p[-1],p[-1]); */
+		n /= 36u;
+		if (i == 4)
+			n += 3u * inc_num;
+	}
+	*p++ = 0;
+	return id;
+}
+
+
 /**
  * \fn TDSDYNAMIC *tds_alloc_dynamic(TDSSOCKET *tds, const char *id)
  * \brief Allocate a dynamic statement.
@@ -94,13 +130,23 @@ TDSDYNAMIC *
 tds_alloc_dynamic(TDSSOCKET * tds, const char *id)
 {
 	TDSDYNAMIC *dyn, *curr;
+	char tmp_id[30];
 
-	/* check to see if id already exists (shouldn't) */
-	for (curr = tds->dyns; curr != NULL; curr = curr->next)
-		if (!strcmp(curr->id, id)) {
-			/* id already exists! just return it */
-			return curr;
+	if (id) {
+		/* check to see if id already exists (shouldn't) */
+		if (tds_lookup_dynamic(tds, id))
+			return NULL;
+	} else {
+		unsigned int n;
+		id = tmp_id;
+
+		for (n = 0;;) {
+			if (!tds_lookup_dynamic(tds, tds_get_dynid(tds, tmp_id)))
+				break;
+			if (++n == 256)
+				return NULL;
 		}
+	}
 
 	dyn = (TDSDYNAMIC *) calloc(1, sizeof(TDSDYNAMIC));
 	if (!dyn)
diff --git a/src/tds/query.c b/src/tds/query.c
index b62fe5c..059aa75 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.227 2008/09/08 19:22:44 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.228 2008/11/05 14:27:49 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, int query_len);
@@ -1012,16 +1012,7 @@ tds_submit_prepare(TDSSOCKET * tds, const char *query, const char *id, TDSDYNAMI
 		return TDS_FAIL;
 
 	/* allocate a structure for this thing */
-	if (!id) {
-		char *tmp_id = NULL;
-
-		if (tds_get_dynid(tds, &tmp_id) == TDS_FAIL)
-			return TDS_FAIL;
-		dyn = tds_alloc_dynamic(tds, tmp_id);
-		free(tmp_id);
-	} else {
-		dyn = tds_alloc_dynamic(tds, id);
-	}
+	dyn = tds_alloc_dynamic(tds, id);
 	if (!dyn)
 		return TDS_FAIL;
 	
@@ -1146,7 +1137,6 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 {
 	int query_len;
 	TDSCOLUMN *param;
-	char *tmp_id = NULL;
 	TDSDYNAMIC *dyn;
 	int id_len;
 
@@ -1210,10 +1200,7 @@ tds_submit_execdirect(TDSSOCKET * tds, const char *query, TDSPARAMINFO * params)
 	}
 
 	/* allocate a structure for this thing */
-	if (tds_get_dynid(tds, &tmp_id) == TDS_FAIL)
-		return TDS_FAIL;
-	dyn = tds_alloc_dynamic(tds, tmp_id);
-	free(tmp_id);
+	dyn = tds_alloc_dynamic(tds, NULL);
 
 	if (!dyn)
 		return TDS_FAIL;
@@ -1763,43 +1750,6 @@ tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags)
 	}
 }
 
-static volatile int inc_num = 1;
-
-/**
- * Get an id for dynamic query based on TDS information
- * \param tds state information for the socket and the TDS protocol
- * \return TDS_FAIL or TDS_SUCCEED
- */
-int
-tds_get_dynid(TDSSOCKET * tds, char **id)
-{
-	unsigned long n;
-	int i;
-	char *p;
-	char c;
-
-	CHECK_TDS_EXTRA(tds);
-
-	inc_num = (inc_num + 1) & 0xffff;
-	/* some version of Sybase require length <= 10, so we code id */
-	n = (unsigned long) (TDS_INTPTR) tds;
-	if (!(p = (char *) malloc(16)))
-		return TDS_FAIL;
-	*id = p;
-	*p++ = (char) ('a' + (n % 26u));
-	n /= 26u;
-	for (i = 0; i < 9; ++i) {
-		c = (char) ('0' + (n % 36u));
-		*p++ = (c < ('0' + 10)) ? c : c + ('a' - '0' - 10);
-		/* printf("%d -> %d(%c)\n",n%36u,p[-1],p[-1]); */
-		n /= 36u;
-		if (i == 4)
-			n += 3u * inc_num;
-	}
-	*p++ = 0;
-	return TDS_SUCCEED;
-}
-
 /**
  * Send a unprepare request for a prepared query
  * \param tds state information for the socket and the TDS protocol
diff --git a/src/tds/unittests/.cvsignore b/src/tds/unittests/.cvsignore
index eb6aa08..6c1a32c 100644
--- a/src/tds/unittests/.cvsignore
+++ b/src/tds/unittests/.cvsignore
@@ -20,3 +20,4 @@ utf8_2
 utf8_3
 numeric
 iconv_fread
+toodynamic
diff --git a/src/tds/unittests/Makefile.am b/src/tds/unittests/Makefile.am
index f2afb7b..3dd84b8 100644
--- a/src/tds/unittests/Makefile.am
+++ b/src/tds/unittests/Makefile.am
@@ -1,10 +1,10 @@
-# $Id: Makefile.am,v 1.23 2007/08/16 08:10:11 freddy77 Exp $
+# $Id: Makefile.am,v 1.24 2008/11/05 14:27:49 freddy77 Exp $
 TESTS		=	t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) t0005$(EXEEXT) t0006$(EXEEXT)\
 			t0007$(EXEEXT) t0008$(EXEEXT) dynamic1$(EXEEXT)\
 			convert$(EXEEXT) dataread$(EXEEXT) utf8_1$(EXEEXT)\
 			utf8_2$(EXEEXT) utf8_3$(EXEEXT) numeric$(EXEEXT) \
-			iconv_fread$(EXEEXT)
+			iconv_fread$(EXEEXT) toodynamic$(EXEEXT)
 
 # flags test commented, not necessary for 0.62
 # TODO add flags test again when needed
@@ -28,6 +28,7 @@ utf8_2_SOURCES	=	utf8_2.c common.c common.h
 utf8_3_SOURCES	=	utf8_3.c common.c common.h
 numeric_SOURCES =       numeric.c
 iconv_fread_SOURCES	= iconv_fread.c
+toodynamic_SOURCES	= toodynamic.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include -I$(srcdir)/.. -I../
 if MINGW32
diff --git a/src/tds/unittests/toodynamic.c b/src/tds/unittests/toodynamic.c
new file mode 100644
index 0000000..aa3b132
--- /dev/null
+++ b/src/tds/unittests/toodynamic.c
@@ -0,0 +1,98 @@
+/* FreeTDS - Library of routines accessing Sybase and Microsoft databases
+ * Copyright (C) 2008 Frediano Ziglio
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public
+ * License along with this library; if not, write to the
+ * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+ * Boston, MA 02111-1307, USA.
+ */
+#include "common.h"
+
+/*
+ * Test creating a lot of dynamics. This can cause some problems cause
+ * generated IDs are reused on a base of 2^16
+ */
+
+static char software_version[] = "$Id: toodynamic.c,v 1.1 2008/11/05 14:27:49 freddy77 Exp $";
+static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
+
+static void
+fatal_error(const char *msg)
+{
+	fprintf(stderr, "%s\n", msg);
+	exit(1);
+}
+
+int
+main(int argc, char **argv)
+{
+	TDSLOGIN *login;
+	TDSSOCKET *tds;
+	int verbose = 0;
+	TDSDYNAMIC *dyn = NULL;
+	int rc;
+	unsigned int n;
+
+	fprintf(stdout, "%s: Test creating a lot of dynamic queries\n", __FILE__);
+	rc = try_tds_login(&login, &tds, __FILE__, verbose);
+	if (rc != TDS_SUCCEED)
+		fatal_error("try_tds_login() failed");
+
+	run_query(tds, "DROP TABLE #test");
+	if (run_query(tds, "CREATE TABLE #test (i INT, c VARCHAR(40))") != TDS_SUCCEED)
+		fatal_error("creating table error");
+
+	if (tds->cur_dyn)
+		fatal_error("already a dynamic query??");
+
+	/* prepare to insert */
+	if (tds_submit_prepare(tds, "UPDATE #test SET c = 'test' WHERE i = ?", NULL, &dyn, NULL) != TDS_SUCCEED)
+		fatal_error("tds_submit_prepare() error");
+	if (tds_process_simple_query(tds) != TDS_SUCCEED)
+		fatal_error("tds_process_simple_query() error");
+	if (!dyn)
+		fatal_error("dynamic not present??");
+
+	/* waste some ids */
+	for (n = 0; n < 65525; ++n) {
+		TDSDYNAMIC *dyn;
+
+		dyn = tds_alloc_dynamic(tds, NULL);
+		if (!dyn)
+			fatal_error("create dynamic");
+
+		tds_free_dynamic(tds, dyn);
+	}
+
+	/* this should not cause duplicate IDs or erros*/
+	for (n = 0; n < 20; ++n) {
+		TDSDYNAMIC *dyn2;
+
+		if (tds_submit_prepare(tds, "INSERT INTO #test(i,c) VALUES(?,?)", NULL, &dyn2, NULL) != TDS_SUCCEED)
+			fatal_error("tds_submit_prepare() error");
+		if (dyn == dyn2)
+			fatal_error("got duplicated dynamic");
+		if (tds_process_simple_query(tds) != TDS_SUCCEED)
+			fatal_error("tds_process_simple_query() error");
+		if (!dyn2)
+			fatal_error("dynamic not present??");
+		if (tds_submit_unprepare(tds, dyn2) != TDS_SUCCEED || tds_process_simple_query(tds) != TDS_SUCCEED)
+			fatal_error("unprepare error");
+		tds_free_dynamic(tds, dyn2);
+	}
+
+
+	try_tds_logout(login, tds, verbose);
+	return 0;
+}
+

